#pragma once

#include "LSToolbox/ROICoder.h"
#include "LSToolbox/DistanceFun.h"
#include "LSToolbox/ActWESolver.h"
#include <list>
// CVWindow frame

using namespace std;

class CMainFrame;
class CVWindow : public CMDIChildWnd
{
	DECLARE_DYNCREATE(CVWindow)
	CMainFrame *pParentFrm;

	
	int width, height;
	IplImage *img;	
	IplImage *firstFrm;
	CvvImage cimg;	
	CvvImage half_img;
	CvvImage double_img;	
	CvvImage show_img;
	int evolveTime;
	enum ZoomSize {HALF,NORMAL,TWICE} ztype;
	double zmfactor;

	//background
	int winx,winy;

	CRect ROI, WinROI;

	BOOL is_showingMMap;

	//Editing state	
	enum ContourState {SELECT, NONE} ctype;
	enum ContourShape {FREEFORM, RECTANGULAR} cshape;
	ROICoder *rcoder;
	DistanceFun *disfun;
	ActWESolver *actwesolver;
	CvPoint startpnt;

	struct KeyPoints
	{
		int x[4], y[4];
	}key_points;
	list<KeyPoints> contours;
//	int x[4], y[4];

	//Value of Parameter
	double mu, v, lambda1, lambda2, p, epsilon, dt, k;
	double scale_factor;
	bool out_video;
	char vpath[100];
	enum solvertype {PDE, GC} stype;

	CvMat *ax;
	CvMat *mux;
	CvMat *region_mask;

	// Switch params
	bool once;  // For show Distance maps
	bool first_time;	// For curve evolving	
	int LBi;		// for show distance maps
	bool first_chgparams;
public:
	BOOL Create(LPCTSTR szTitle, LONG style = 0,
		const RECT& rect = rectDefault,
		CMainFrame* pParent = NULL);
protected:
	CVWindow();
public:
	CVWindow(char *pathname);           // protected constructor used by dynamic creation
	virtual ~CVWindow();

protected:
	DECLARE_MESSAGE_MAP()
public:
	void DrawCV(CDC* pdc);
	afx_msg void OnPaint();
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnButtonDrawCurve();
	afx_msg void OnButtonShowDMap();
	afx_msg void OnButtonShowMMap();
	afx_msg void OnButtonEvolveCurve();
	afx_msg void OnButtonAutoEvolve();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnSaveFile();
	afx_msg void OnClose();
	afx_msg void OnUpdateMButton(CCmdUI *pCmdUI);
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
};


