#pragma once

#include "ROICoder.h"
#include "fheap/fib.h"
#include "fheap/fibpriv.h"
#include "config.h"
typedef bool (*T_callback_intert_node)(int i, int j, int ii, int jj);

#define ACCESS_ARRAY(a,i,j) a[(i)+n*(j)]
#define D_(i,j) ACCESS_ARRAY(D,i,j)
#define S_(i,j) ACCESS_ARRAY(S,i,j)
#define W_(i,j) 1.0//ACCESS_ARRAY(W,i,j) // We only calculate distance function
#define H_(i,j) ACCESS_ARRAY(H,i,j)
#define heap_pool_(i,j) ACCESS_ARRAY(heap_pool,i,j)

#define start_points_(i,k) start_points[(i)+2*(k)]
#define end_points_(i,k) end_points[(i)+2*(k)]

class DistanceFun
{
public:
	ROICoder *rcoder;
	CvMat* disfun;	
public:
	float maxvalue;
	enum NodeType {kDead, kOpen, kFar} ;

	/* Global variables */
	int n;			// width
	int p;			// height
	double* D;
	double* S;
	double* W;
	double* start_points;
	double* end_points;
	double* H;
	int nb_iter_max;
	int nb_start_points;
	int nb_end_points;
	fibheap_el** heap_pool;	
public:
	DistanceFun(ROICoder *roicoder);
	~DistanceFun(void);
	void CalcuDisFun(int simple);
	float GetDisFun(int x, int y);
	CvMat * GetDisFun();
	void perform_front_propagation_2d(T_callback_intert_node callback_insert_node);
	void ErrMsgTxt(char *s);
	bool end_points_reached(const int i, const int j );
};
