#pragma once
/*
	ROICoder 
	Function: dynamically encode the contour of the user assigned contour
	all the encoded point are relative position to the startpoint
*/

struct ImNode
{
	CvPoint pos; //position of the node;
	int dir; //direction of the next node, the same as freeman code
	enum NodeType{N,M,S}; // For computation of inside / outside of the contour
	NodeType ntype;
	ImNode(){ntype = N;}
};

class ROICoder
{
	// Data structures for contour coding
	CvSeq *contour[10];
	CvMemStorage *mem;//If it run out of memory, will it reallocate automatically by seqpush?
	CvPoint startpnt;	
	IplImage *regionmask;// 0: boundary; 1: outside; -1:inside
	int contour_num;


public:
	BOOL circular;// true if the contour is closed
	CvPoint prepnt;//Previously added point
	enum state {BEGIN, PROCEED, END} curstate;
	int rowmin, rowmax;// record the max and min row number of the selected contour
	int colmin, colmax;

	ImNode *cur_node;	// temporally record previous pushed node for calculating directional property
public:
	ROICoder(int width, int height, bool circular);
	~ROICoder(void);
	void BeginContour(CvPoint startpnt);
	void AddContourNode(CvPoint pnt);
	void EndContour();
	int imageWidth();
	int imageHeight();
	CvSeq* getContour(int);
	void CodeNType(void);
	// Encode the inner region of the contour, denoted -1 in regionmask
	void CodeRegion(void);
	// Find the node type in the position pos
	ImNode::NodeType FindNodeType(CvPoint pos);
	IplImage * GetRegionMask(void);
	int getCNum();
};
