// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "TPCut.h"

#include "MainFrm.h"
#include ".\mainfrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	ON_WM_CREATE()

	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND_EX(IDR_FILE_TOOLBAR, OnBarCheck )
	ON_UPDATE_COMMAND_UI(IDR_FILE_TOOLBAR, OnUpdateControlBarMenu)
//	ON_WM_SHOWWINDOW()
ON_COMMAND(IDR_VIEW_TOOLBAR, OnViewToolbar)
ON_UPDATE_COMMAND_UI(IDR_VIEW_TOOLBAR, OnUpdateViewToolbar)
ON_COMMAND(ID_VIEW_CONTROLBAR, OnViewControlbar)
ON_UPDATE_COMMAND_UI(ID_VIEW_CONTROLBAR, OnUpdateViewControlbar)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	IDS_PANE_COORD_X,
	IDS_PANE_COORD_Y,
	IDS_PANE_FRAMES_NUMBER,
	IDS_PANE_TIME_PERF,
	IDS_PANE_TIME_TOTAL
};


// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	mu =  1.00;
	lambda1 =  10;
	lambda2 = 10;
	dt = 10;
	k = 10;
	vout = true;
	stype = 1;
	cshape = 0;
	
	chdwnd = NULL;
	strcpy(vfname, "c:/video.avi");
}

CMainFrame::~CMainFrame()
{
}


int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndFileToolBar.Create(this,WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC, IDR_CONTROL_BAR) ||		
		!m_wndFileToolBar.LoadToolBar(IDR_FILE_TOOLBAR))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndControlBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndControlBar.LoadToolBar(IDR_CBAR)) //CONTROL_BAR))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}	

// 	if (!m_wndDlgBar.Create(this, IDD_FORMVIEW,
// 		CBRS_LEFT|CBRS_TOOLTIPS|CBRS_FLYBY, IDD_FORMVIEW))
// 	{
// 		TRACE0("Failed to create DlgBar\n");
// 		return -1;      // fail to create
// 	}
	// Set default parameter
// 	CEdit *edit;
// 	char buff[100];
// 	edit = (CEdit*)m_wndDlgBar.GetDlgItem(IDC_MU);
// 	_gcvt(mu,10,buff);
// 	edit ->SetWindowText(buff);
// 
// 	edit = (CEdit*)m_wndDlgBar.GetDlgItem(IDC_LAMBDA1);
// 	_gcvt(lambda1,10,buff);
// 	edit ->SetWindowText(buff);
// 
// 	edit = (CEdit*)m_wndDlgBar.GetDlgItem(IDC_LAMBDA2);
// 	_gcvt(lambda2,10,buff);
// 	edit ->SetWindowText(buff);
// 
// 	edit = (CEdit*)m_wndDlgBar.GetDlgItem(IDC_DT);
// 	_gcvt(dt,10,buff);
// 	edit ->SetWindowText(buff);
// 
// 	edit = (CEdit*)m_wndDlgBar.GetDlgItem(IDC_K);
// 	_gcvt(dt,10,buff);
// 	edit ->SetWindowText(buff);
// 
// 	edit = (CEdit*)m_wndDlgBar.GetDlgItem(IDC_EDIT_AVIPATH);	
// 	edit ->SetWindowText(vfname);
// 
// 	CComboBox *combo = (CComboBox*)m_wndDlgBar.GetDlgItem(IDC_COMBO_ALG);
// 	combo->SetCurSel(0);
// 
// 	combo = (CComboBox*)m_wndDlgBar.GetDlgItem(IDC_COMBO_CTYPE);
// 	combo->SetCurSel(1);
// 
// 	combo = (CComboBox*)m_wndDlgBar.GetDlgItem(IDC_COMBO_ZOOM);
// 	combo->SetCurSel(1);
// 
// 	CButton *checkbox = (CButton*)m_wndDlgBar.GetDlgItem(IDC_CHECK1);
// 	checkbox->SetCheck(0);
	
	// TODO: Delete these three lines if you don't want the toolbar to be dockable
	m_wndFileToolBar.EnableDocking(CBRS_ALIGN_ANY);
	m_wndControlBar.EnableDocking(CBRS_ALIGN_ANY);
//	m_wndDlgBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndFileToolBar);
	DockControlBar(&m_wndControlBar,AFX_IDW_DOCKBAR_LEFT);//BOTTOM);
//	DockControlBar(&m_wndDlgBar,AFX_IDW_DOCKBAR_RIGHT);
	RecalcLayout();

	return 0;
}

void CMainFrame::OnFileOpen()
{
/*	if(chdwnd != NULL){
		AfxMessageBox("Only one child window at one time allowed!");
		return;
	}
*/	char BASED_CODE szFilter[] ="BMP Files (*.bmp)|*.bmp|JPEG Files (*.jpg)|*.jpg|";
	CFileDialog dlg( TRUE, "bmp", NULL, OFN_HIDEREADONLY,szFilter);
	if(dlg.DoModal()!=IDOK) 
		return;
	
	chdwnd = new CVWindow(dlg.GetPathName().GetBuffer());
	if (!chdwnd->Create(dlg.GetPathName(),WS_CHILD | WS_VISIBLE|WS_OVERLAPPEDWINDOW|WS_MAXIMIZE, rectDefault, this))//
		return;	
}


BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CMDIFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}


// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}
#endif //_DEBUG

void CMainFrame::SetXCoord(int x)
{
	char str[100];
	sprintf(str, "X: %d", x);
	m_wndStatusBar.SetPaneText(1,str);
}

void CMainFrame::SetYCoord(int y)
{
	char str[100];
	sprintf(str, "Y: %d", y);
	m_wndStatusBar.SetPaneText(2,str);
}

void CMainFrame::SetFrmNum(int fn)
{
	char str[100];
	sprintf(str, "Frame: %d", fn);
	m_wndStatusBar.SetPaneText(3,str);
}

void CMainFrame::SetFrmTime(__time64_t time)
{
	char str[100];
	sprintf(str, "%ld ms/step", time);
	m_wndStatusBar.SetPaneText(4,str);
}

void CMainFrame::SetTotalTime(__time64_t ltime)
{
	char str[100];
	sprintf(str, "%ld ms total", ltime);
	m_wndStatusBar.SetPaneText(5,str);
}

void CMainFrame::OnUpdateControlBar()//CCmdUI* pCmdUI)
{	
}


// CMainFrame message handlers


void CMainFrame::ClearChdWnd(void)
{
	chdwnd = NULL;
}



void CMainFrame::OnViewToolbar()
{
	ShowControlBar(&m_wndFileToolBar,(m_wndFileToolBar.GetStyle() & WS_VISIBLE) == 0,FALSE);
}

void CMainFrame::OnUpdateViewToolbar(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck((m_wndFileToolBar.GetStyle() & WS_VISIBLE) ? 1 : 0);
}

void CMainFrame::OnViewControlbar()
{
	ShowControlBar(&m_wndControlBar,(m_wndControlBar.GetStyle() & WS_VISIBLE) == 0,FALSE);
}

void CMainFrame::OnUpdateViewControlbar(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck((m_wndControlBar.GetStyle() & WS_VISIBLE) ? 1 : 0);
}
